PROBLEM LINK:Setter: Kirill Gulin DIFFICULTY:Simple PREREQUISITES:BFS, Maxheap/Priority Queue, Greedy PROBLEM:Given a $N*M$ grid with certain forbidden cells (represented by 1) where Chef cannot enter, Empty cells (represented by 0) where chef can enter and exit, and Escape Cells (represented by x>0) using which Chef can escape from grid if he can reach escape cell from any cell within x seconds, i.e. the distance from escape cell must be at most x. Find out from which NonForbidden cells from where the chef escape and print it in specified format. STRATEGY TO SOLVEA Tempting greedy but Wrong solution The intuitive idea to solve this problem is For every node with value Greater than 0, run a BFS, mark the node as visited and terminating BFS when distance become greater than x. This strategy fail for following test case: 1 In this case, if we visit the position with value 2 first, we will either have to reprocess the same position with value 3 (while processing 4), thus getting either TLE or WA, depending upon implementation. Why above solution doesn't work Suppose we process a position with lower grid value first. Then later, it might happen, that we visit the same node with higher value of x. Here, if we choose to process it again, we will get TLE in 2nd subtask, because our solution become $O((N*M)^2)$ in worst case. If we choose not to process this vertex again, there is a the possibility that a node earlier not reachable with initial grid value, now become reachable with higher value of x, thus giving us WA. This gives shape to the ideal strategy to get the correct solution. Correct Solution:The element with maximum value should be processed first of all. Now, this way, whenever we reach a position already visited, we can simply ignore it because we have already processed this position with a higher value of x, Thus, keeping Time Complexity to $O(N*M*log(N*M))$ (Log factor added for insert and delete operations of Maxheap. Our final solution become to maintain a maxheap, running a BFS. Due care must be taken to ensure that a position does not get inserted into heap twice, to keep our solution within time limit. Tester's implementation: An $O(N*M + maxA)$ spproach.With the same idea, Tester made a vector V array of size $max(A)$ , storing all the position $(i,j)$ in $V[grid[i][j]]$ for $grid[i][j]>0$. This way, we run a loop from maxA to 0, and for each position in $V[x]$, we add all its neighbours which are not already processed into $V[x1]$ and also mark them as visited. This way, we save the Log factor associated with insertion in maxheap, thus, getting $O(N*M+maxA)$ runtime. Complexity: AUTHOR'S AND TESTER'S SOLUTIONS:
This question is marked "community wiki".
asked 22 Jan '18, 23:33

@vivek 3 node (0,1) is processed that gives value 2 to (1,1) then it is processed which gives value 1 to (2,1). now node (3,2) is processed which gives value 1 to (3,1) which when processed marks (4,1) as Y. there might be insertions needed while processing any node that's why we use a priority queue instead of a static array to get nmlog(nm) complexity. My sol:https://www.codechef.com/viewsolution/17173110 answered 27 Jan '18, 23:52

after reading the editorial and seeing tester's solution i finally got ac , so thought this might help i've heavily commented the code inorder to understand better. Anyone not getting anystep of tester's solution can see my code here
link
This answer is marked "community wiki".
answered 28 Jan '18, 17:56

Weak test cases in the problem. https://discuss.codechef.com/questions/122121/wrongsolutionspassingweaktestcasesinjanlunchtimel56laby answered 27 Jan '18, 23:22

I constructed a binary maze matrix and applied bfs on it..then I saved all those i,j which were >0 and than ran a source to destination bfs for every i,j and the saved i,j(obviously on those i,j which equal 0). I should have sorted the saved i,j according to max value..would have got a right answer.. answered 28 Jan '18, 03:51

can someone give some tricky test cases so that it can help everyone who got wrong. thanks in advance
link
This answer is marked "community wiki".
answered 28 Jan '18, 12:55

Used the same approach as of tester but the code is throwing Segmentation fault. Unable to debug the cause. Can anyone help? Solution Link: Code answered 29 Jan '18, 20:46
Check for i>0 before accessing its neighbours.
(30 Jan '18, 10:34)
Figured it out last night. Still thank you. Silly mistake!
(31 Jan '18, 13:28)

please someone find error in my code i ran few test cases but that are fine :( answered 31 Jan '18, 02:42
